git-rebase.sh 7.98 KB
Newer Older
1 2 3 4 5
#!/bin/sh
#
# Copyright (c) 2005 Junio C Hamano.
#

6
USAGE='[-v] [--onto <newbase>] <upstream> [<branch>]'
7 8 9 10 11
LONG_USAGE='git-rebase replaces <branch> with a new branch of the
same name.  When the --onto option is provided the new branch starts
out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
It then attempts to create a new commit for each commit from the original
<branch> that does not exist in the <upstream> branch.
12

13 14
It is possible that a merge failure will prevent this process from being
completely automatic.  You will have to resolve any such merge failure
15 16 17 18
and run git rebase --continue.  Another option is to bypass the commit
that caused the merge failure with git rebase --skip.  To restore the
original <branch> and remove the .dotest working files, use the command
git rebase --abort instead.
19

20 21 22
Note that if <branch> is not specified on the command line, the
currently checked out branch is used.  You must be in the top
directory of your project to start (or continue) a rebase.
23

24
Example:       git-rebase master~1 topic
25

26 27 28
        A---B---C topic                   A'\''--B'\''--C'\'' topic
       /                   -->           /
  D---E---F---G master          D---E---F---G master
29
'
30
. git-sh-setup
31

32 33 34 35 36
RESOLVEMSG="
When you have resolved this problem run \"git rebase --continue\".
If you would prefer to skip this patch, instead run \"git rebase --skip\".
To restore the original branch and stop rebasing run \"git rebase --abort\".
"
37
unset newbase
38
strategy=recursive
39 40 41
do_merge=
dotest=$GIT_DIR/.dotest-merge
prec=4
42
verbose=
43 44 45 46 47 48 49 50 51 52

continue_merge () {
	test -n "$prev_head" || die "prev_head must be defined"
	test -d "$dotest" || die "$dotest directory does not exist"

	unmerged=$(git-ls-files -u)
	if test -n "$unmerged"
	then
		echo "You still have unmerged paths in your index"
		echo "did you forget update-index?"
53
		die "$RESOLVEMSG"
54 55 56 57
	fi

	if test -n "`git-diff-index HEAD`"
	then
58 59 60 61 62 63
		if ! git-commit -C "`cat $dotest/current`"
		then
			echo "Commit failed, please do not call \"git commit\""
			echo "directly, but instead do one of the following: "
			die "$RESOLVEMSG"
		fi
64
		printf "Committed: %0${prec}d" $msgnum
65
	else
66
		printf "Already applied: %0${prec}d" $msgnum
67
	fi
68 69
	echo ' '`git-rev-list --pretty=oneline -1 HEAD | \
				sed 's/^[a-f0-9]\+ //'`
70 71 72 73 74 75 76

	prev_head=`git-rev-parse HEAD^0`
	# save the resulting commit so we can read-tree on it later
	echo "$prev_head" > "$dotest/prev_head"

	# onto the next patch:
	msgnum=$(($msgnum + 1))
77
	echo "$msgnum" >"$dotest/msgnum"
78 79 80
}

call_merge () {
81
	cmt="$(cat $dotest/cmt.$1)"
82 83 84 85 86
	echo "$cmt" > "$dotest/current"
	git-merge-$strategy "$cmt^" -- HEAD "$cmt"
	rv=$?
	case "$rv" in
	0)
87
		return
88 89 90
		;;
	1)
		test -d "$GIT_DIR/rr-cache" && git-rerere
91
		die "$RESOLVEMSG"
92 93 94
		;;
	2)
		echo "Strategy: $rv $strategy failed, try another" 1>&2
95
		die "$RESOLVEMSG"
96 97 98 99 100 101 102 103 104 105 106 107 108
		;;
	*)
		die "Unknown exit code ($rv) from command:" \
			"git-merge-$strategy $cmt^ -- HEAD $cmt"
		;;
	esac
}

finish_rb_merge () {
	rm -r "$dotest"
	echo "All done."
}

109 110 111
while case "$#" in 0) break ;; esac
do
	case "$1" in
112 113 114 115 116 117 118 119
	--continue)
		diff=$(git-diff-files)
		case "$diff" in
		?*)	echo "You must edit all merge conflicts and then"
			echo "mark them as resolved using git update-index"
			exit 1
			;;
		esac
120 121 122 123 124 125 126 127 128 129 130 131 132 133 134
		if test -d "$dotest"
		then
			prev_head="`cat $dotest/prev_head`"
			end="`cat $dotest/end`"
			msgnum="`cat $dotest/msgnum`"
			onto="`cat $dotest/onto`"
			continue_merge
			while test "$msgnum" -le "$end"
			do
				call_merge "$msgnum"
				continue_merge
			done
			finish_rb_merge
			exit
		fi
135 136
		git am --resolved --3way --resolvemsg="$RESOLVEMSG" \
			--reflog-action=rebase
137 138 139
		exit
		;;
	--skip)
140 141
		if test -d "$dotest"
		then
142 143 144 145 146 147 148 149 150 151 152 153
			prev_head="`cat $dotest/prev_head`"
			end="`cat $dotest/end`"
			msgnum="`cat $dotest/msgnum`"
			msgnum=$(($msgnum + 1))
			onto="`cat $dotest/onto`"
			while test "$msgnum" -le "$end"
			do
				call_merge "$msgnum"
				continue_merge
			done
			finish_rb_merge
			exit
154
		fi
155 156
		git am -3 --skip --resolvemsg="$RESOLVEMSG" \
			--reflog-action=rebase
157 158 159
		exit
		;;
	--abort)
160 161 162 163 164 165 166 167 168
		if test -d "$dotest"
		then
			rm -r "$dotest"
		elif test -d .dotest
		then
			rm -r .dotest
		else
			die "No rebase in progress?"
		fi
169 170 171
		git reset --hard ORIG_HEAD
		exit
		;;
172 173 174 175 176
	--onto)
		test 2 -le "$#" || usage
		newbase="$2"
		shift
		;;
177 178 179 180 181 182 183 184
	-M|-m|--m|--me|--mer|--merg|--merge)
		do_merge=t
		;;
	-s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
		--strateg=*|--strategy=*|\
	-s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
		case "$#,$1" in
		*,*=*)
Dennis Stosberg's avatar
Dennis Stosberg committed
185
			strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
186 187 188 189 190 191 192 193
		1,*)
			usage ;;
		*)
			strategy="$2"
			shift ;;
		esac
		do_merge=t
		;;
194 195 196
	-v|--verbose)
		verbose=t
		;;
197 198 199 200 201 202 203 204 205
	-*)
		usage
		;;
	*)
		break
		;;
	esac
	shift
done
206

207
# Make sure we do not have .dotest
208
if test -z "$do_merge"
209
then
210 211 212 213 214
	if mkdir .dotest
	then
		rmdir .dotest
	else
		echo >&2 '
215 216 217 218
It seems that I cannot create a .dotest directory, and I wonder if you
are in the middle of patch application or another rebase.  If that is not
the case, please rm -fr .dotest and run me again.  I am stopping in case
you still have something valuable there.'
219 220 221 222 223 224 225 226
		exit 1
	fi
else
	if test -d "$dotest"
	then
		die "previous dotest directory $dotest still exists." \
			'try git-rebase < --continue | --abort >'
	fi
227 228
fi

229
# The tree must be really really clean.
Junio C Hamano's avatar
Junio C Hamano committed
230
git-update-index --refresh || exit
231
diff=$(git-diff-index --cached --name-status -r HEAD)
Lukas Sandström's avatar
Lukas Sandström committed
232
case "$diff" in
233 234 235 236
?*)	echo "$diff"
	exit 1
	;;
esac
Junio C Hamano's avatar
Junio C Hamano committed
237

238 239 240
# The upstream head must be given.  Make sure it is valid.
upstream_name="$1"
upstream=`git rev-parse --verify "${upstream_name}^0"` ||
Jason Riedy's avatar
Jason Riedy committed
241
    die "invalid upstream $upstream_name"
Lukas Sandström's avatar
Lukas Sandström committed
242

243 244 245 246 247 248 249 250 251
# If a hook exists, give it a chance to interrupt
if test -x "$GIT_DIR/hooks/pre-rebase"
then
	"$GIT_DIR/hooks/pre-rebase" ${1+"[email protected]"} || {
		echo >&2 "The pre-rebase hook refused to rebase."
		exit 1
	}
fi

252
# If the branch to rebase is given, first switch to it.
253
case "$#" in
254
2)
255
	branch_name="$2"
256
	git-checkout "$2" || usage
257 258 259
	;;
*)
	branch_name=`git symbolic-ref HEAD` || die "No current branch"
260
	branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
261
	;;
262
esac
263
branch=$(git-rev-parse --verify "${branch_name}^0") || exit
264

265 266 267
# Make sure the branch to rebase onto is valid.
onto_name=${newbase-"$upstream_name"}
onto=$(git-rev-parse --verify "${onto_name}^0") || exit
Lukas Sandström's avatar
Lukas Sandström committed
268

269 270 271 272
# Now we are rebasing commits $upstream..$branch on top of $onto

# Check if we are already based on $onto, but this should be
# done only when upstream and onto are the same.
273 274
mb=$(git-merge-base "$onto" "$branch")
if test "$upstream" = "$onto" && test "$mb" = "$onto"
275
then
276 277
	echo >&2 "Current branch $branch_name is up to date."
	exit 0
278 279
fi

280 281 282 283 284 285
if test -n "$verbose"
then
	echo "Changes from $mb to $onto:"
	git-diff-tree --stat --summary "$mb" "$onto"
fi

286 287
# Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
git-reset --hard "$onto"
Lukas Sandström's avatar
Lukas Sandström committed
288

289
# If the $onto is a proper descendant of the tip of the branch, then
Lukas Sandström's avatar
Lukas Sandström committed
290
# we just fast forwarded.
291
if test "$mb" = "$branch"
Lukas Sandström's avatar
Lukas Sandström committed
292
then
293
	echo >&2 "Fast-forwarded $branch_name to $onto_name."
Lukas Sandström's avatar
Lukas Sandström committed
294 295 296
	exit 0
fi

297 298
if test -z "$do_merge"
then
299
	git-format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
300 301
	git am --binary -3 -k --resolvemsg="$RESOLVEMSG" \
		--reflog-action=rebase
302 303 304
	exit $?
fi

305
if test "@@[email protected]@" && test "$strategy" = "recursive-old"
306
then
307
	die 'The recursive-old merge strategy is written in Python,
308
which this installation of git was not configured with.  Please consider
309
a different merge strategy (e.g. recursive, resolve, or stupid)
310 311 312 313
or install Python and git with Python support.'

fi

314 315 316 317 318 319 320 321 322 323
# start doing a rebase with git-merge
# this is rename-aware if the recursive (default) strategy is used

mkdir -p "$dotest"
echo "$onto" > "$dotest/onto"
prev_head=`git-rev-parse HEAD^0`
echo "$prev_head" > "$dotest/prev_head"

msgnum=0
for cmt in `git-rev-list --no-merges "$upstream"..ORIG_HEAD \
Michal Rokos's avatar
Michal Rokos committed
324
			| @@[email protected]@ -e 'print reverse <>'`
325 326
do
	msgnum=$(($msgnum + 1))
327
	echo "$cmt" > "$dotest/cmt.$msgnum"
328 329
done

330 331
echo 1 >"$dotest/msgnum"
echo $msgnum >"$dotest/end"
332 333 334 335 336 337 338 339 340

end=$msgnum
msgnum=1

while test "$msgnum" -le "$end"
do
	call_merge "$msgnum"
	continue_merge
done
341

342
finish_rb_merge